# coding: utf-8

"""
    Mozart platform API

    API for interacting with the Mozart platform.  # noqa: E501

    The version of the OpenAPI document: 0.2.0
    Contact: support@bang-olufsen.dk
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from datetime import datetime
from typing import List, Dict, Literal, Optional


from mozart_api.configuration import Configuration


class BeolinkLeader(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {"friendly_name": "str", "jid": "str"}

    attribute_map = {"friendly_name": "friendlyName", "jid": "jid"}

    def __init__(
        self,
        friendly_name: Optional[str] = None,
        jid: Optional[str] = None,
        local_vars_configuration=None,
    ):  # noqa: E501
        """BeolinkLeader - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._friendly_name = None
        self._jid = None
        self.discriminator = None

        self.friendly_name = friendly_name
        self.jid = jid

    @property
    def friendly_name(self):
        # type: () -> str
        """Gets the friendly_name of this BeolinkLeader.  # noqa: E501


        :return: The friendly_name of this BeolinkLeader.  # noqa: E501
        :rtype: str
        """
        return self._friendly_name

    @friendly_name.setter
    def friendly_name(self, friendly_name):
        # type: (str) -> None
        """Sets the friendly_name of this BeolinkLeader.


        :param friendly_name: The friendly_name of this BeolinkLeader.  # noqa: E501
        :type friendly_name: str
        :rtype: None
        """
        if (
            self.local_vars_configuration.client_side_validation
            and friendly_name is None
        ):  # noqa: E501
            raise ValueError(
                "Invalid value for `friendly_name`, must not be `None`"
            )  # noqa: E501

        self._friendly_name = friendly_name

    @property
    def jid(self):
        # type: () -> str
        """Gets the jid of this BeolinkLeader.  # noqa: E501

        Beolink peer ID  # noqa: E501

        :return: The jid of this BeolinkLeader.  # noqa: E501
        :rtype: str
        """
        return self._jid

    @jid.setter
    def jid(self, jid):
        # type: (str) -> None
        """Sets the jid of this BeolinkLeader.

        Beolink peer ID  # noqa: E501

        :param jid: The jid of this BeolinkLeader.  # noqa: E501
        :type jid: str
        :rtype: None
        """
        if (
            self.local_vars_configuration.client_side_validation and jid is None
        ):  # noqa: E501
            raise ValueError(
                "Invalid value for `jid`, must not be `None`"
            )  # noqa: E501

        self._jid = jid

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BeolinkLeader):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, BeolinkLeader):
            return True

        return self.to_dict() != other.to_dict()
