# coding: utf-8

"""
    Mozart platform API

    API for interacting with the Mozart platform.  # noqa: E501

    The version of the OpenAPI document: 0.2.0
    Contact: support@bang-olufsen.dk
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from datetime import datetime
from typing import List, Dict, Literal, Optional


from mozart_api.configuration import Configuration


class ButtonEvent(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {"button": "str", "state": "str"}

    attribute_map = {"button": "button", "state": "state"}

    def __init__(
        self,
        button: Optional[str] = None,
        state: Optional[str] = None,
        local_vars_configuration=None,
    ):  # noqa: E501
        """ButtonEvent - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._button = None
        self._state = None
        self.discriminator = None

        if button is not None:
            self.button = button
        if state is not None:
            self.state = state

    @property
    def button(self):
        # type: () -> str
        """Gets the button of this ButtonEvent.  # noqa: E501

        identifies the button  # noqa: E501

        :return: The button of this ButtonEvent.  # noqa: E501
        :rtype: str
        """
        return self._button

    @button.setter
    def button(self, button):
        # type: (str) -> None
        """Sets the button of this ButtonEvent.

        identifies the button  # noqa: E501

        :param button: The button of this ButtonEvent.  # noqa: E501
        :type button: str
        :rtype: None
        """

        self._button = button

    @property
    def state(self):
        # type: () -> str
        """Gets the state of this ButtonEvent.  # noqa: E501

        identifies the state change  # noqa: E501

        :return: The state of this ButtonEvent.  # noqa: E501
        :rtype: str
        """
        return self._state

    @state.setter
    def state(self, state):
        # type: (str) -> None
        """Sets the state of this ButtonEvent.

        identifies the state change  # noqa: E501

        :param state: The state of this ButtonEvent.  # noqa: E501
        :type state: str
        :rtype: None
        """

        self._state = state

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ButtonEvent):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ButtonEvent):
            return True

        return self.to_dict() != other.to_dict()
