# coding: utf-8

"""
    Mozart platform API

    API for interacting with the Mozart platform.  # noqa: E501

    The version of the OpenAPI document: 0.2.0
    Contact: support@bang-olufsen.dk
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from datetime import datetime
from typing import List, Dict, Literal, Optional


from mozart_api.configuration import Configuration


class HdmiInput(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {"content_uri": "str", "input": "str"}

    attribute_map = {"content_uri": "contentUri", "input": "input"}

    def __init__(
        self,
        content_uri: Optional[str] = None,
        input: Optional[str] = None,
        local_vars_configuration=None,
    ):  # noqa: E501
        """HdmiInput - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._content_uri = None
        self._input = None
        self.discriminator = None

        if content_uri is not None:
            self.content_uri = content_uri
        if input is not None:
            self.input = input

    @property
    def content_uri(self):
        # type: () -> str
        """Gets the content_uri of this HdmiInput.  # noqa: E501

        This points to the editable content trigger for this specific hdmi input  # noqa: E501

        :return: The content_uri of this HdmiInput.  # noqa: E501
        :rtype: str
        """
        return self._content_uri

    @content_uri.setter
    def content_uri(self, content_uri):
        # type: (str) -> None
        """Sets the content_uri of this HdmiInput.

        This points to the editable content trigger for this specific hdmi input  # noqa: E501

        :param content_uri: The content_uri of this HdmiInput.  # noqa: E501
        :type content_uri: str
        :rtype: None
        """

        self._content_uri = content_uri

    @property
    def input(self):
        # type: () -> str
        """Gets the input of this HdmiInput.  # noqa: E501


        :return: The input of this HdmiInput.  # noqa: E501
        :rtype: str
        """
        return self._input

    @input.setter
    def input(self, input):
        # type: (str) -> None
        """Sets the input of this HdmiInput.


        :param input: The input of this HdmiInput.  # noqa: E501
        :type input: str
        :rtype: None
        """

        self._input = input

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, HdmiInput):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, HdmiInput):
            return True

        return self.to_dict() != other.to_dict()
