# coding: utf-8

"""
    Mozart platform API

    API for interacting with the Mozart platform.  # noqa: E501

    The version of the OpenAPI document: 0.2.0
    Contact: support@bang-olufsen.dk
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from datetime import datetime
from typing import List, Dict, Literal, Optional


from mozart_api.configuration import Configuration


class OverlayPlayRequestFromUsbFromUsb(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {"file_location": "str"}

    attribute_map = {"file_location": "fileLocation"}

    def __init__(
        self, file_location: Optional[str] = None, local_vars_configuration=None
    ):  # noqa: E501
        """OverlayPlayRequestFromUsbFromUsb - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._file_location = None
        self.discriminator = None

        self.file_location = file_location

    @property
    def file_location(self):
        # type: () -> str
        """Gets the file_location of this OverlayPlayRequestFromUsbFromUsb.  # noqa: E501

        Required field containing the relative path (i.e. from the USB drive root) and file name with extension (if one exists) that will be played. A maximum length of 1024 characters is allowed.   # noqa: E501

        :return: The file_location of this OverlayPlayRequestFromUsbFromUsb.  # noqa: E501
        :rtype: str
        """
        return self._file_location

    @file_location.setter
    def file_location(self, file_location):
        # type: (str) -> None
        """Sets the file_location of this OverlayPlayRequestFromUsbFromUsb.

        Required field containing the relative path (i.e. from the USB drive root) and file name with extension (if one exists) that will be played. A maximum length of 1024 characters is allowed.   # noqa: E501

        :param file_location: The file_location of this OverlayPlayRequestFromUsbFromUsb.  # noqa: E501
        :type file_location: str
        :rtype: None
        """
        if (
            self.local_vars_configuration.client_side_validation
            and file_location is None
        ):  # noqa: E501
            raise ValueError(
                "Invalid value for `file_location`, must not be `None`"
            )  # noqa: E501
        if (
            self.local_vars_configuration.client_side_validation
            and file_location is not None
            and len(file_location) > 1024
        ):
            raise ValueError(
                "Invalid value for `file_location`, length must be less than or equal to `1024`"
            )  # noqa: E501

        self._file_location = file_location

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OverlayPlayRequestFromUsbFromUsb):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OverlayPlayRequestFromUsbFromUsb):
            return True

        return self.to_dict() != other.to_dict()
