# coding: utf-8

"""
    Mozart platform API

    API for interacting with the Mozart platform.  # noqa: E501

    The version of the OpenAPI document: 0.2.0
    Contact: support@bang-olufsen.dk
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from datetime import datetime
from typing import List, Dict, Literal, Optional


from mozart_api.configuration import Configuration


class OverlayPlayRequestTextToSpeechTextToSpeech(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {"lang": "str", "text": "str"}

    attribute_map = {"lang": "lang", "text": "text"}

    def __init__(
        self,
        lang: Optional[str] = None,
        text: Optional[str] = None,
        local_vars_configuration=None,
    ):  # noqa: E501
        """OverlayPlayRequestTextToSpeechTextToSpeech - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._lang = None
        self._text = None
        self.discriminator = None

        self.lang = lang
        self.text = text

    @property
    def lang(self):
        # type: () -> str
        """Gets the lang of this OverlayPlayRequestTextToSpeechTextToSpeech.  # noqa: E501

        An optional specification of the language to use. The default value is ultimately decided by the BeoCloud API, but currently it defaults to `en-us`.   # noqa: E501

        :return: The lang of this OverlayPlayRequestTextToSpeechTextToSpeech.  # noqa: E501
        :rtype: str
        """
        return self._lang

    @lang.setter
    def lang(self, lang):
        # type: (str) -> None
        """Sets the lang of this OverlayPlayRequestTextToSpeechTextToSpeech.

        An optional specification of the language to use. The default value is ultimately decided by the BeoCloud API, but currently it defaults to `en-us`.   # noqa: E501

        :param lang: The lang of this OverlayPlayRequestTextToSpeechTextToSpeech.  # noqa: E501
        :type lang: str
        :rtype: None
        """

        self._lang = lang

    @property
    def text(self):
        # type: () -> str
        """Gets the text of this OverlayPlayRequestTextToSpeechTextToSpeech.  # noqa: E501

        Required field containing the actual text that will be converted to speech (audio). A maximum length of 2048 characters is allowed.   # noqa: E501

        :return: The text of this OverlayPlayRequestTextToSpeechTextToSpeech.  # noqa: E501
        :rtype: str
        """
        return self._text

    @text.setter
    def text(self, text):
        # type: (str) -> None
        """Sets the text of this OverlayPlayRequestTextToSpeechTextToSpeech.

        Required field containing the actual text that will be converted to speech (audio). A maximum length of 2048 characters is allowed.   # noqa: E501

        :param text: The text of this OverlayPlayRequestTextToSpeechTextToSpeech.  # noqa: E501
        :type text: str
        :rtype: None
        """
        if (
            self.local_vars_configuration.client_side_validation and text is None
        ):  # noqa: E501
            raise ValueError(
                "Invalid value for `text`, must not be `None`"
            )  # noqa: E501
        if (
            self.local_vars_configuration.client_side_validation
            and text is not None
            and len(text) > 2048
        ):
            raise ValueError(
                "Invalid value for `text`, length must be less than or equal to `2048`"
            )  # noqa: E501

        self._text = text

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OverlayPlayRequestTextToSpeechTextToSpeech):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OverlayPlayRequestTextToSpeechTextToSpeech):
            return True

        return self.to_dict() != other.to_dict()
