# coding: utf-8

"""
    Mozart platform API

    API for interacting with the Mozart platform.  # noqa: E501

    The version of the OpenAPI document: 0.2.0
    Contact: support@bang-olufsen.dk
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from datetime import datetime
from typing import List, Dict, Literal, Optional

from mozart_api.models.content_item import ContentItem

from mozart_api.configuration import Configuration


class RemoteMenuItemAllOf(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        "available": "bool",
        "content": "ContentItem",
        "fixed": "bool",
        "id": "str",
    }

    attribute_map = {
        "available": "available",
        "content": "content",
        "fixed": "fixed",
        "id": "id",
    }

    def __init__(
        self,
        available: Optional[bool] = None,
        content: Optional[ContentItem] = None,
        fixed: Optional[bool] = None,
        id: Optional[str] = None,
        local_vars_configuration=None,
    ):  # noqa: E501
        """RemoteMenuItemAllOf - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._available = None
        self._content = None
        self._fixed = None
        self._id = None
        self.discriminator = None

        self.available = available
        if content is not None:
            self.content = content
        self.fixed = fixed
        self.id = id

    @property
    def available(self):
        # type: () -> bool
        """Gets the available of this RemoteMenuItemAllOf.  # noqa: E501


        :return: The available of this RemoteMenuItemAllOf.  # noqa: E501
        :rtype: bool
        """
        return self._available

    @available.setter
    def available(self, available):
        # type: (bool) -> None
        """Sets the available of this RemoteMenuItemAllOf.


        :param available: The available of this RemoteMenuItemAllOf.  # noqa: E501
        :type available: bool
        :rtype: None
        """

        self._available = available

    @property
    def content(self):
        # type: () -> ContentItem
        """Gets the content of this RemoteMenuItemAllOf.  # noqa: E501


        :return: The content of this RemoteMenuItemAllOf.  # noqa: E501
        :rtype: ContentItem
        """
        return self._content

    @content.setter
    def content(self, content):
        # type: (ContentItem) -> None
        """Sets the content of this RemoteMenuItemAllOf.


        :param content: The content of this RemoteMenuItemAllOf.  # noqa: E501
        :type content: ContentItem
        :rtype: None
        """

        self._content = content

    @property
    def fixed(self):
        # type: () -> bool
        """Gets the fixed of this RemoteMenuItemAllOf.  # noqa: E501

        True if this is a fixed menu item. A fixed item can't be deleted or moved  # noqa: E501

        :return: The fixed of this RemoteMenuItemAllOf.  # noqa: E501
        :rtype: bool
        """
        return self._fixed

    @fixed.setter
    def fixed(self, fixed):
        # type: (bool) -> None
        """Sets the fixed of this RemoteMenuItemAllOf.

        True if this is a fixed menu item. A fixed item can't be deleted or moved  # noqa: E501

        :param fixed: The fixed of this RemoteMenuItemAllOf.  # noqa: E501
        :type fixed: bool
        :rtype: None
        """
        if (
            self.local_vars_configuration.client_side_validation and fixed is None
        ):  # noqa: E501
            raise ValueError(
                "Invalid value for `fixed`, must not be `None`"
            )  # noqa: E501

        self._fixed = fixed

    @property
    def id(self):
        # type: () -> str
        """Gets the id of this RemoteMenuItemAllOf.  # noqa: E501

        Unique ID for this menu item  # noqa: E501

        :return: The id of this RemoteMenuItemAllOf.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        # type: (str) -> None
        """Sets the id of this RemoteMenuItemAllOf.

        Unique ID for this menu item  # noqa: E501

        :param id: The id of this RemoteMenuItemAllOf.  # noqa: E501
        :type id: str
        :rtype: None
        """
        if (
            self.local_vars_configuration.client_side_validation and id is None
        ):  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RemoteMenuItemAllOf):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, RemoteMenuItemAllOf):
            return True

        return self.to_dict() != other.to_dict()
