# coding: utf-8

"""
    Mozart platform API

    API for interacting with the Mozart platform.  # noqa: E501

    The version of the OpenAPI document: 0.2.0
    Contact: support@bang-olufsen.dk
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from datetime import datetime
from typing import List, Dict, Literal, Optional


from mozart_api.configuration import Configuration


class SceneMatch(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {"label": "str", "tags": "list[str]"}

    attribute_map = {"label": "label", "tags": "tags"}

    def __init__(
        self,
        label: Optional[str] = None,
        tags: Optional[List[str]] = None,
        local_vars_configuration=None,
    ):  # noqa: E501
        """SceneMatch - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._label = None
        self._tags = None
        self.discriminator = None

        self.label = label
        if tags is not None:
            self.tags = tags

    @property
    def label(self):
        # type: () -> str
        """Gets the label of this SceneMatch.  # noqa: E501


        :return: The label of this SceneMatch.  # noqa: E501
        :rtype: str
        """
        return self._label

    @label.setter
    def label(self, label):
        # type: (str) -> None
        """Sets the label of this SceneMatch.


        :param label: The label of this SceneMatch.  # noqa: E501
        :type label: str
        :rtype: None
        """

        self._label = label

    @property
    def tags(self):
        # type: () -> List[str]
        """Gets the tags of this SceneMatch.  # noqa: E501

        A list of user defined tags. This allows a client to create virtual lists  # noqa: E501

        :return: The tags of this SceneMatch.  # noqa: E501
        :rtype: List[str]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        # type: (list[str]) -> None
        """Sets the tags of this SceneMatch.

        A list of user defined tags. This allows a client to create virtual lists  # noqa: E501

        :param tags: The tags of this SceneMatch.  # noqa: E501
        :type tags: list[str]
        :rtype: None
        """

        self._tags = tags

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SceneMatch):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SceneMatch):
            return True

        return self.to_dict() != other.to_dict()
